#ifndef ROBOT_CTRL_INTERFACE_H
#define ROBOT_CTRL_INTERFACE_H

/*
  ړ{bg̐C^[tF[X

  Satofumi KAMIMURA

  $Id$
*/

#include "GridTypes.h"
#include "FollowLineInterface.h"
#include "GetPositionInterface.h"


class RobotCtrlInterface
  : public FollowLineInterface, public GetPositionInterface {

public:
  virtual ~RobotCtrlInterface() {}

  virtual void startFollowLine(void) = 0;

  virtual const char* what(void) = 0;

  virtual bool updateEvent(void) = 0;

  virtual bool connect(void) = 0;

  virtual void setSteerOffset(int offset_degree) = 0;

  virtual void setSteer(int degree) = 0;

  virtual void setVelocity(int velocity_km) = 0;

  // ~
  // !!! ̂ StopInterface Ɋ܂܂邩
  virtual void stop(void) = 0;

  virtual int getVelocity(void) = 0;

  // 莩Ȉʒu̎擾
  //virtual Position<int> getPosition(void) = 0;

  // Wn̎擾
  virtual CoordinateCtrl* getCoordinate(void) = 0;
};

#endif /* !ROBOT_CTRL_INTERFACE_H */
