#ifndef SIMULATION_INTERFACE_H
#define SIMULATION_INTERFACE_H

/*
  ڕWoHւ̈ړ{bgǏ]vO(V~[Vp)

  Satofumi KAMIMURA

  $Id$
*/

#include "RobotCtrlInterface.h"
#include <memory>


class SimulationCtrl : public RobotCtrlInterface {

  SimulationCtrl(const SimulationCtrl& rhs);
  SimulationCtrl& operator = (const SimulationCtrl& rhs);

  struct pImpl;
  const std::auto_ptr<pImpl> pimpl;

public:
  SimulationCtrl(void);
  ~SimulationCtrl(void);
  const char* what(void);
  bool updateEvent(void);

  bool connect(void);
  void startFollowLine(void);
  void setSteer(int degree);
  void setSteerOffset(int offset_degree);
  void setVelocity(int velocity_km);
  void follow_line(const CoordinateCtrl* crd, const Position<int>& position);
  int getLength_toLine(const CoordinateCtrl* crd, const Position<int>& line);
  void stop(void);
  int getVelocity(void);
  Position<int> getPosition(const CoordinateCtrl* crd);
  CoordinateCtrl* getCoordinate(void);
};

#endif /* !SIMULATION_INTERFACE_H */
