/*
	オドメトリを受け取りその周囲DISTANCEぶんのマップを抜き出すプログラム
	thによる方角の変換も行う
	mainを復帰させてコマンドラインからx,y,thをあたえることでテスト可能
*/
#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include "aroundmap.h"

#if 0
int main(int argv,char *argc[])
{
  double x,y,th;
  int returnnum;
  
  x = atof(argc[1]);
  y = atof(argc[2]);
  th = atof(argc[3]);
  
  returnnum = aroundmap(x,y,th);

  printf("returnnum = %d\n",returnnum);
  return 0;
}
#endif
int aroundmap(double x,double y,double th)
{
  FILE *fpin,*fpout;
  double mapx,mapy;
  double sinth,sinmth,cosmth;
  char s[32];
  
  const double DISTANCE = 49000000.0;
  const double D2R = 3.14159265358979323846/180.0;

  sinth = sin(th * D2R);
  sinmth = sin(-th * D2R);
  cosmth = cos(-th * D2R);

  if(y < 3000)
  {
    fpin = fopen("map-10000_-10000_50000_10000.map","r");
//    printf("map-10000_-10000_50000_10000.map open \n");
  }
  else if(x > 37000)
  {
    fpin = fopen("map30000_-10000_50000_30000.map","r");
//    printf("map30000_-10000_50000_30000.map open \n");
  }
  else if(y > 16000)
  {
    fpin = fopen("map-10000_10000_50000_30000.map","r");
//    printf("map-10000_10000_50000_30000.map open \n");
  }
  else if(x < 4000)
  {
    fpin = fopen("map-10000_-10000_10000_30000.map","r");
//    printf("map-10000_-10000_10000_30000.map open \n");
  }
  else
  {
    fpin = fopen("clearmap.map","r");
    printf("clearmap.map open \n");
  }
  if(fpin == NULL)
  {
    fprintf(stderr,"I could not open map data¥n");
    return -1;
  }

  fpout = fopen("aroundmap.map","w");
  if(fpout == NULL)
    {
      fprintf(stderr,"I could not opne aroundmap.map¥n");
      fclose(fpin);
      return -1;
    }

  while(fgets(s,31,fpin) != NULL)
    {
      sscanf(s,"%*s %lf %lf",&mapx,&mapy);
      if( ((mapx - x)*(mapx - x) + (mapy - y)*(mapy - y)) < DISTANCE )
	{
//	  fprintf(fpout,"a %lf %lf\n",mapx-x ,mapy-y);
	  fprintf(fpout,"a %lf %lf\n",(mapx - x)*cosmth + (mapy -y)*sinth,(mapx - x)*sinmth + (mapy-y)*cosmth);
	}
    }

  fclose(fpin);
  fclose(fpout);
  return 0;
}
